#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    conjure_object::private::DeriveWith
)]
#[serde(crate = "conjure_object::serde")]
#[derive_with(PartialEq, Eq, PartialOrd, Ord, Hash)]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct StabilityDetectionRangesNode {
    #[builder(custom(type = super::NumericSeriesNode, convert = Box::new))]
    #[serde(rename = "input")]
    input: Box<super::NumericSeriesNode>,
    #[builder(custom(type = super::Threshold, convert = Box::new))]
    #[serde(rename = "threshold")]
    threshold: Box<super::Threshold>,
    #[builder(custom(type = super::PersistenceWindowConfiguration, convert = Box::new))]
    #[serde(rename = "windowConfiguration")]
    window_configuration: Box<super::PersistenceWindowConfiguration>,
}
impl StabilityDetectionRangesNode {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(
        input: super::NumericSeriesNode,
        threshold: super::Threshold,
        window_configuration: super::PersistenceWindowConfiguration,
    ) -> Self {
        Self::builder()
            .input(input)
            .threshold(threshold)
            .window_configuration(window_configuration)
            .build()
    }
    #[inline]
    pub fn input(&self) -> &super::NumericSeriesNode {
        &*self.input
    }
    #[inline]
    pub fn threshold(&self) -> &super::Threshold {
        &*self.threshold
    }
    #[inline]
    pub fn window_configuration(&self) -> &super::PersistenceWindowConfiguration {
        &*self.window_configuration
    }
}
